#!/usr/local/bin/perl

# The thing we're looking for
$keyword = $ARGV[0];

# The apropos command to execute
$apropos = '/usr/ucb/apropos';

# The machine's fully qualified hostname
$hostname = 'wildlife.ora.com';

# The Gopher Port number
$port = 70;

# Make sure the manpath is correct
$ENV{'MANPATH'} = "/usr/man:/usr/local/man";

# Execute the apropos command, putting its output into the @response array
open(RESPONSE, "-|") || exec "$apropos", "$keyword";
@response = <RESPONSE>;

# Do NOT do this, for security reasons (see the next section)
# @response = `$apropos $keyword`;

# Now parse each line of apropos' output
foreach (@response) {

  # Chop off the Return at the end of the line
  chop;

  # Take out the tabs (and spaces) from the description.
  # We don't want any tabs because tabs are used in the Gopher protocol,
  # and would confuse the server.
  s/[ \t]*-[ \t]*/ - /;

  # Figure out the command apropos returned, putting the manual entry's
  # name into $1 and the manual entry's section number into $2  
  /(\w+)[ \t,]+\((\d*)[\w]*\) - /;

  # Give the server the command to execute to bring up this manual page.
  # This returns lines that will look like:
  #0apropos-info<tab>exec:"manual-section manual-name":script<tab>host<tab>port
  #
  # Where script is the full pathname of the script, relative to the
  # Gopher directory.
  print "0$_\texec:\"$2 $1\":/.man-get\t$hostname\t$port\t\n";
}
